<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)

// Initialise execution
$startLoadTime = microtime(true);
set_time_limit(10);

// Include UNB libraries
$libPath = '../unb_lib/';
#require_once $libPath . 'unb_all.lib.php';
if (!class_exists('UnbMarkup')) require_once $libPath . 'markup.class.php';
if (!class_exists('UnbCaptcha')) require_once $libPath . 'captcha.class.php';
if (!class_exists('UnbUi')) require_once $libPath . 'ui.class.php';
if (!class_exists('UnbLocale')) require_once $libPath . 'locale.class.php';
if (!function_exists('unbtr')) require_once $libPath . 'global.lib.php';

// Localisation support
include '_app_dict.inc.php';
#UnbLocale::Prefer('en-GB');
UnbLocale::AutoPrefer();
#UnbLocale::SetTimeZone('UTC');

// Make sure output buffering is active.
UnbEnvironment::SetupEnvironment();
// Re-enable error display in testing environment.
ini_restore('display_errors');

$startExecTime = microtime(true);

// Maximum level of replies to show on one page
$messageThreadMaxLevel = 7;

if (!defined('NOHTML'))
{
	header('Content-Type: text/html; charset=utf-8');
	?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html>
<head>
<title>UNB2 Demo Application</title>
<link rel="stylesheet" type="text/css" href="common.css" />
<link rel="stylesheet" type="text/css" href="markup.css" />
<!--[if IE]><link rel="stylesheet" type="text/css" href="common_ie.css" /><![endif]-->
<script src="dynamic-complete.js" type="text/javascript"></script>
</head>
<body>

<?php

// DEBUG
/*if ($_POST)
{
	echo '<pre>';
	print_r($_POST);
	echo '</pre>';
}*/

} // if (!defined('NOHTML'))

UnbDebug::StartErrorHandling(true);

// Now that the HTML page is ready and error handling is set up, initialise the rest.
// The settings file name is relative to the UNB library source path.
UNB::Init('../unb_config.inc.php');

if (!defined('NOHTML'))
{
?>
<div class="head">
<div class="logo">
UNB2 Demo Application
</div>

<!-- Login controls -->
<div style="float: right;">
<?php UnbUi::UserLoginLink('login.php', 'create_user.php?userid=%i', 'login.php?action=logout&urlkey=%k', 'logout_warning.php') ?>
</div>

<!-- Page navigation -->
<div>
<a href="index.php"><?php echo unbtr('page:start page') ?></a> &nbsp;–&nbsp;
<a href="list_deps.php"><?php echo unbtr('page:discussions') ?></a> &nbsp;–&nbsp;
<a href="list_tags.php"><?php echo unbtr('page:tags') ?></a> &nbsp;–&nbsp;
<a href="list_users.php"><?php echo unbtr('page:users') ?></a>
</div>
<div style="clear: both;"></div>
</div><!-- .head -->

<?php
} // if (!defined('NOHTML'))
?>