<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	if ($_POST['addfileto_revisionid'])
	{
		// The new file was added to another message
		UnbSession::SetVar('SuccessMessage', 'File saved');
		if ($_POST['add_another_file'])
		{
			UnbUi::RedirectAndExit('create_file.php?addrid=' . intval($_POST['addfileto_revisionid']));
		}
		else
		{
			UnbUi::RedirectAndExit('create_message.php?drarid=' . intval($_POST['addfileto_revisionid']));
		}
	}

	UnbUi::GetFormHandler()->GetMessageIds($messageId, $revisionId);
	if ($revisionId > 0)
		UnbUi::RedirectAndExit('view_message.php?messagerevisionid=' . $revisionId);
	else
		UnbUi::RedirectAndExit('view_message.php?messageid=' . $messageId);
}

UnbUi::BeginReport();
UnbUi::ReportSuccess();
UnbUi::ReportError();

$addToRevisionId = isset($_REQUEST['addrid']) ? intval($_REQUEST['addrid']) : null;
// ----- Load the message revision -----
$alterMessageId = isset($_REQUEST['altmid']) ? intval($_REQUEST['altmid']) : null;
$alterRevisionId = isset($_REQUEST['altrid']) ? intval($_REQUEST['altrid']) : null;

$error = false;
if (!UnbSession::IsLoggedIn())
{
	UnbUi::ReportError('Not logged in');
	$error = true;
}
// Check/Try to alter a message
else if ((isset($alterMessageId) || isset($alterRevisionId)) &&
	!UnbUi::GetMsgRev($alterMessageId, $alterRevisionId, $alterMsg, $alterRev, $err))
{
	UnbUi::ReportError($err);
	$error = true;
}
UnbUi::EndReport();

if (!$error)
{
	$alterMode = isset($alterMsg);

	if ($alterMode)
		echo '<h1>Alter file</h1>';
	else if (isset($addToRevisionId))
		echo '<h1>Add a new file to a message</h1>';
	else
		echo '<h1>Create a new file</h1>';
	?>

	<?php UnbUi::BeginForm('create_file.php', true) ?>
	<?php if ($addToRevisionId) UnbUi::FormFileAddToMsgRev($addToRevisionId) ?>
	<?php if ($alterMode) UnbUi::FormMsgRev($alterRev->GetMessageRevisionId()) ?>

	<script type="text/javascript" src="editor-plaintype.js"></script>
	<table cellspacing="0" class="full-width grid first-10em">
	<?php
	if (!$alterMode || UnbUi::CanAlterMsg($alterMsg, $alterRev))
	{
		?>
		<tr>
			<td class="vspace">Upload file:</td>
			<td><?php UnbUi::MsgAttach(!$alterMode, null) ?></td>
		</tr>
		<tr>
			<td class="vspace">Description:<br />(optional)</td>
			<td>
				<?php UnbUi::MsgContent(!$alterMode, $alterMsg, $alterRev, null, 'width: 45em; height: 8em;|monospace') ?>
			</td>
		</tr>
		<?php
		if ($alterMode)
		{
			?>
			<tr>
				<td class="vspace">Changes summary:</td>
				<td><?php UnbUi::MsgSummary(null, 'width: 45em;') ?></td>
			</tr>
			<?php
		}
	}
	else if ($alterMode)   // Implies that the message cannot be altered
	{
		?>
		<tr>
			<td>Subject:</td>
			<td><?php echo htmlspecialchars($alterRev->GetSubject()) ?></td>
		</tr>
		<?php
	}
	?>
	</table>

	<a class="sectionToggle" id="tagsHeader" href="javascript:undefined">Tags</a>

	<div class="section" id="tagsDiv">
	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td>Tags:</td>
		<td><?php UnbUi::MsgTags($alterRev) ?></td>
	</tr>
	</table>
	</div>

	<?php
	if (UnbSession::IsModerator())
	{
		?>
		<a class="sectionToggle" id="msgPropsHeader" href="javascript:undefined">Message properties</a>

		<div class="section" id="msgPropsDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Page name:</td>
			<td><?php UnbUi::MsgPageName($alterMsg) ?></td>
		</tr>
		</table>
		</div>
		<?php
	}
	?>

	<?php
	if (UnbSession::IsLoggedIn() &&
		(!$alterMode || UnbSession::IsAdministrator() || UnbUi::IsMsgOwner($alterMsg)))
	{
		$readAccessData = null;
		$alterAccessData = array(UnbUserKey::Moderator, UnbSession::GetSessionUserId());

		if ($alterMode)
		{
			$readAccessData = $alterMsg;
			$alterAccessData = $alterMsg;
		}
		?>
		<a class="sectionToggle" id="msgAccessHeader" href="javascript:undefined">Message access</a>

		<div class="section" id="msgAccessDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Reading allowed to:</td>
			<td><?php UnbUi::MsgReadAccessList($readAccessData, null, 'width: 20em;') ?></td>
		</tr>
		<tr>
			<td class="vspace">Alteration allowed to:</td>
			<td><?php UnbUi::MsgAlterAccessList($alterAccessData, null, 'width: 20em;') ?></td>
		</tr>
		</table>
		</div>
		<?php
	}
	?>

	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td></td>
		<td colspan="2">
			<br />
			<?php
			if ($alterMode)
				$label = 'Save changes';
			else
				$label = 'Create new file';
			?>
			<input type="submit" class="default icon13 ok" value="<?php echo $label ?>" />
			<?php
			if (!$alterMode)
			{
				?>
				&nbsp; <input type="submit" name="add_another_file" class="icon13 ok" value="Create and add another file" />
				<?php
			}
			if (isset($addToRevisionId))
			{
				?>
				&nbsp; <a href="create_message.php?drarid=<?php echo $addToRevisionId ?>" class="buttonlike icon13 back">Back to message editor</a>
				<?php
			}
			if ($alterMode && UnbSession::IsModerator())
			{
				?>
				&nbsp; <a href="delete_message.php?messageid=<?php echo $alterMsg->GetMessageId() ?>" class="buttonlike icon13 delete">Delete this file…</a>
				<?php
			}
			?>
		</td>
	</tr>
	</table>
	<?php UnbUi::EndForm() ?>

	<script type="text/javascript">//<![CDATA[
	function toggleSection(id, state)
	{
		DOM.toggleClass("#" + id + "Header", "collapsed", -DOM.toggleVisible("#" + id + "Div", state));
	}

	["msgProps", "tags", "msgAccess"].each(function (id)
	{
		DOMEvents.add("#" + id + "Header", "click", function (e) { toggleSection(id); e.target.blur(); });
	});

	//$("#subjectTb").focus();
	toggleSection("msgProps");
	toggleSection("tags");
	toggleSection("msgAccess");
	//]]></script>

	<?php
}

require('_foot.inc.php');
?>