<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	if (UnbUi::GetFormHandler()->GetNewTag())
		UnbSession::SetVar('SuccessMessage', 'Tag created');
	else
		UnbSession::SetVar('SuccessMessage', 'Tag saved');
	UnbUi::RedirectAndExit('list_tags.php');
}

UnbUi::BeginReport();
UnbUi::ReportSuccess();
UnbUi::ReportError();

// ----- Load the tag -----
$alterTagId = isset($_REQUEST['tagid']) ? intval($_REQUEST['tagid']) : null;

if (isset($alterTagId))
{
	$alterTag = UnbTag::FindByTagId($alterTagId);
}

$error = false;
if (!isset($alterTag) && !UnbSession::IsModerator() ||
	isset($alterTag) && !UnbSession::IsModerator() && !UnbSession::IsAdministrator())
{
	UnbUi::ReportError('Access denied');
	$error = true;
}
else if (isset($alterTagId) && !isset($alterTag))
{
	UnbUi::ReportError('Invalid tag ID');
	$error = true;
}
UnbUi::EndReport();

if (!$error)
{
	if (isset($alterTag))
		echo '<h1>Alter tag ' . unbqt(htmlspecialchars($alterTag->GetTagName())) . '</h1>';
	else
		echo '<h1>Create a new tag</h1>';
	?>

	<?php UnbUi::BeginForm('create_tag.php?' . $_SERVER['QUERY_STRING']) ?>
	<?php
	if (isset($alterTag))
		UnbUi::FormTag($alterTag->GetTagId());
	else
		echo '<input type="hidden" name="action[]" value="create_tag" />';
	?>

	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td class="vspace">Tag name:</td>
		<td><?php UnbUi::TagName($alterTag, null, UnbSession::IsModerator() ? '' : '||disabled') ?></td>
		<td class="form-description">This is the visible tag name.</td>
	</tr>
	<tr>
		<td class="vspace">Description:</td>
		<td><?php UnbUi::TagDescription($alterTag, null, UnbSession::IsModerator() ? '' : '||disabled') ?></td>
		<td class="form-description">The description of this tag explains the user when and why to use it.</td>
	</tr>
	<tr>
		<td>Flags:</td>
		<td><?php UnbUi::TagFlags($alterTag, !UnbSession::IsModerator()) ?></td>
		<td class="form-description">Flags set special tag behaviour options.</td>
	</tr>
	<tr>
		<td class="vspace">Parent tag:</td>
		<td><?php UnbUi::ParentTag($alterTag, null, UnbSession::IsModerator() ? '' : '||disabled') ?></td>
		<td class="form-description">A tag’s parent tag is used to organise tags in a tree hierarchy. Invisible or user data tags cannot be used as a parent.</td>
	</tr>
	<tr>
		<td class="vspace">Read access for:</td>
		<td><?php UnbUi::TagReadAccessList($alterTag, null, 'width: 20em;' . (UnbSession::IsAdministrator() ? '' : '||disabled')) ?></td>
		<td class="form-description">List of user names or keys that can read messages with this tag, one per line.</td>
	</tr>
	<tr>
		<td class="vspace">Usage access for:</td>
		<td><?php UnbUi::TagUseAccessList($alterTag, null, 'width: 20em;' . (UnbSession::IsAdministrator() ? '' : '||disabled')) ?></td>
		<td class="form-description">List of user names or keys that can assign this tag to messages, one per line.</td>
	</tr>
	<tr>
		<td></td>
		<td colspan="2">
			<br />
			<?php
			if (isset($alterTag))
				$label = 'Save changes';
			else
				$label = 'Create tag';
			?>
			<input type="submit" class="default icon13 ok" value="<?php echo $label ?>" /> &nbsp;
			<a href="list_tags.php" class="buttonlike icon13 back">Back to tags list</a>
			<?php
			if (isset($alterTag) && UnbSession::IsModerator())
			{
				?>
				&nbsp; <a href="delete_tag.php?tagid=<?php echo $alterTag->GetTagId() ?>" class="buttonlike icon13 delete">Delete this tag…</a>
				<?php
			}
			?>
		</td>
	</tr>
	</table>
	<?php UnbUi::EndForm() ?>

	<script type="text/javascript">//<![CDATA[
	$("#tagNameTb").focus();
	//]]></script>

	<?php
}
require('_foot.inc.php');
?>