<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	UnbSession::SetVar('SuccessMessage', 'Tag deleted');
	UnbUi::RedirectAndExit('list_tags.php');
}

UnbUi::BeginReport();
UnbUi::ReportError();

// ----- Load the tag -----
$error = false;
$tag = UnbTag::FindByTagId(intval($_REQUEST['tagid']));
if (!UnbSession::IsModerator())
{
	UnbUi::ReportError('Access denied');
	$error = true;
}
if (!isset($tag))
{
	UnbUi::ReportError('Invalid tag ID');
	$error = true;
}
UnbUi::EndReport();

if (!$error)
{
	?>
	<h1>Delete tag <?php echo unbqt(htmlspecialchars($tag->GetTagName())) ?></h1>

	<p>
	To permanently delete this tag, press the button below. All access lists and message associations for this tag will be deleted automatically.
	</p>

	<?php UnbUi::BeginForm() ?>
	<?php UnbUi::FormTag($tag->GetTagId()) ?>
	<input type="hidden" name="action[]" value="delete_tag" />

	<p>
	<input type="submit" class="default icon13 delete" value="Delete this tag" /> &nbsp;
	<a href="alter_tag.php?tagid=<?php echo $tag->GetTagId() ?>" class="buttonlike icon13 back">Back to tag</a>
	</p>
	<?php UnbUi::EndForm() ?>

	<?php
}

require('_foot.inc.php');
?>