function PlainTypeEm(textbox)
{
	_PlainTypeEncloseText(textbox, "''", "''");
	// TODO: Don't remove if the selection/text starts with ''' (which is one ' more)
}

function PlainTypeStrong(textbox)
{
	_PlainTypeEncloseText(textbox, "'''", "'''");
}

function PlainTypeUnderline(textbox)
{
	_PlainTypeEncloseText(textbox, "<u>", "</u>");
}

function PlainTypeStrike(textbox)
{
	_PlainTypeEncloseText(textbox, "<s>", "</s>");
}

function PlainTypeQuote(textbox)
{
	_PlainTypeStartLine(textbox, "> ");
}

function PlainTypeIndent(textbox)
{
	_PlainTypeStartLine(textbox, "    ");
}

function PlainTypeUList(textbox)
{
	_PlainTypeStartLine(textbox, "* ");
}

function PlainTypeOList(textbox)
{
	_PlainTypeStartLine(textbox, "# ");
}

function PlainTypeCode(textbox)
{
	_PlainTypeEncloseText(textbox, "{{{", "}}}");
}

function PlainTypeLink(textbox)
{
	_PlainTypeEncloseText(textbox, "[[", "]]");
}

function PlainTypeInsert(textbox, str)
{
	if (isString(textbox))
		textbox = $("#" + textbox);

	if (textbox.selectionStart >= 0)
	{
		var start_selection = textbox.selectionStart;
		var scroll_top = textbox.scrollTop;
		var scroll_left = textbox.scrollLeft;

		// fetch everything from start of text area to selection start
		var before = textbox.value.substring(0, start_selection);
		// fetch everything from end of selection to end of text area
		var after = textbox.value.substring(start_selection, textbox.textLength);

		textbox.value = before + str + after;

		textbox.selectionStart = textbox.selectionEnd = start_selection + str.length;
		textbox.focus();
		textbox.scrollTop = scroll_top;
		textbox.scrollLeft = scroll_left;
	}
	else
	{
		// TODO: IE support
		textbox.value += tOpen + tClose;
		textbox.focus();
	}
}

function _PlainTypeEncloseText(textbox, tOpen, tClose)
{
	if (isString(textbox))
		textbox = $("#" + textbox);

	if (textbox.selectionEnd && (textbox.selectionEnd - textbox.selectionStart > 0))
	{
		var start_selection = textbox.selectionStart;
		var end_selection = textbox.selectionEnd;
		var new_endsel;
		var scroll_top = textbox.scrollTop;
		var scroll_left = textbox.scrollLeft;

		// exclude line breaks from the end
		while (end_selection - start_selection > 1 && textbox.value.substr(end_selection - 1, 1) == "\n")
			end_selection--;

		// fetch everything from start of text area to selection start
		var before = textbox.value.substring(0, start_selection);
		// fetch everything from start of selection to end of selection
		var seltext = textbox.value.substring(start_selection, end_selection);
		// fetch everything from end of selection to end of text area
		var after = textbox.value.substring(end_selection, textbox.textLength);

		if (seltext.substring(0, tOpen.length) == tOpen &&
			seltext.substring(seltext.length - tClose.length, seltext.length) == tClose)
		{
			// tags are already there, remove them
			seltext = seltext.substring(tOpen.length, seltext.length - tClose.length);
			new_endsel = end_selection - tOpen.length - tClose.length;
		}
		else
		{
			seltext = tOpen + seltext + tClose;
			new_endsel = end_selection + tOpen.length + tClose.length;
		}

		textbox.value = before + seltext + after;

		textbox.selectionStart = start_selection;
		textbox.selectionEnd = new_endsel;
		textbox.focus();
		textbox.scrollTop = scroll_top;
		textbox.scrollLeft = scroll_left;
	}
	else if (textbox.selectionStart >= 0)
	{
		// no selection, insert opening/closing tags alone
		var start_selection = textbox.selectionStart;
		var end_selection = textbox.selectionEnd;
		var scroll_top = textbox.scrollTop;
		var scroll_left = textbox.scrollLeft;

		// fetch everything from start of text area to selection start
		var before = textbox.value.substring(0, start_selection);
		// fetch everything from end of selection to end of text area
		var after = textbox.value.substring(end_selection, textbox.textLength);

		textbox.value = before + tOpen + tClose + after;

		textbox.selectionStart = textbox.selectionEnd = start_selection + tOpen.length;
		textbox.focus();
		textbox.scrollTop = scroll_top;
		textbox.scrollLeft = scroll_left;
	}
	else
	{
		// TODO: IE support
		textbox.value += tOpen + tClose;
		textbox.focus();
	}
}

function _PlainTypeStartLine(textbox, lineStart)
{
	if (isString(textbox))
		textbox = $("#" + textbox);

	if (textbox.selectionStart >= 0)
	{
		var start_selection = textbox.selectionStart;
		var end_selection = textbox.selectionEnd;
		var scroll_top = textbox.scrollTop;
		var scroll_left = textbox.scrollLeft;

		// exclude line breaks from the end
		while (end_selection - start_selection > 1 && textbox.value.substr(end_selection - 1, 1) == "\n")
			end_selection--;

		// find the beginning of the current line
		for (var i = start_selection; i > 0; i--)
		{
			if (textbox.value.charCodeAt(i) == 10)
			{
				i++;
				break;
			}
		}
		start_selection = i;

		// process multiple selected lines - find the end of the last line
		for (var j = end_selection; j < textbox.value.length - 1; j++)
		{
			if (textbox.value.charCodeAt(j) == 10)
			{
				break;
			}
		}
		end_selection = j;

		// fetch everything from start of text area to selection start
		var before = textbox.value.substring(0, start_selection);
		// fetch everything from end of selection to end of text area
		var after = textbox.value.substring(end_selection, textbox.textLength);

		var middle = textbox.value.substring(start_selection, end_selection);
		var addedCount = middle.length;
		// replace all line breaks except the last one
		middle = middle.replace(/\n(?!$)/g, "\n" + lineStart);
		addedCount = middle.length - addedCount;
		addedCount += lineStart.length;   // add the first line

		textbox.value = before + lineStart + middle + after;

		textbox.selectionStart = start_selection;
		textbox.selectionEnd = end_selection + addedCount;
		textbox.focus();
		textbox.scrollTop = scroll_top;
		textbox.scrollLeft = scroll_left;
	}
	else
	{
		// TODO: IE support
	}
}

