<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

UnbUi::BeginReport();
UnbUi::ReportSuccess();
UnbUi::EndReport();

echo '<h1>' . unbtrc('caption:discussions list') . '</h1>';

if ($draftRevs = UnbUi::GetDraftRevisions())
{
	echo '<p class="drafts-list">';
	echo unbtrc('saved drafts', count($draftRevs)) . unbcol() . '<br />';
	foreach ($draftRevs as $rev)
	{
		echo '<a href="create_message.php?drarid=' . $rev->GetMessageRevisionId() . '">' . htmlspecialchars($rev->GetSubject()) . '</a>';
		echo ' &nbsp; ' . unbtrc('last saved') . ' ';
		UnbUi::RelativeTime($rev->GetCreatedTime());
		echo '<br />';
	}
	echo '</p>';
}

try
{
	$searchParameters = array();
	$searchParameters['entrypoint'] = true;
	$searchParameters['sort-createdtime'] = true;
	$searchParameters['sort-reverse'] = true;
	$messageIds = UnbSearch::Query($searchParameters);

	echo '<p>';
	echo unbtrc('n discussions in the list', count($messageIds));
	echo ' &nbsp;–&nbsp; <a href="create_message.php" class="buttonlike icon13 create">' . unbtrc('button:create a new message') . '</a>';
	if (UnbSession::IsLoggedIn())
		echo ' <a href="create_file.php" class="buttonlike icon13 create">' . unbtrc('button:create a new file') . '</a>';
	echo '</p>';

	$markup = new UnbMarkup();
	$discussionCount = 0;
	if ($messageIds) foreach ($messageIds as $messageId)
	{
		$discussionCount++;

		$msg = UnbMessage::FindByMessageId($messageId);
		if (!isset($msg)) continue;   // Actually, this should not happen here anymore

		$latestRev = $msg->GetLatestRevision(UnbMessageRevisionContentLevel::Subject, true);
		if (!isset($latestRev)) continue;   // Actually, this should not happen here anymore
		if ($msg->GetSearchRevisionId() != $latestRev->GetMessageRevisionId())
			$searchRev = $msg->GetSearchRevision(UnbMessageRevisionContentLevel::Subject, true);
		else
			$searchRev = $latestRev;
		if (!isset($searchRev)) continue;   // Actually, this should not happen here anymore

		echo '<div class="discussion' . ($discussionCount == 1 ? ' first' : '') . '">';
		echo '<div class="subject-line">';
		echo '<span class="subject">';
		if ($searchRev->GetContentLevel() >= UnbMessageRevisionContentLevel::Subject)
		{
			if (strlen($searchRev->GetSubject()))
				$text = htmlspecialchars($searchRev->GetSubject());
			else
				$text = '(No subject set)';

			echo '<a href="view_message.php?messageid=' . $msg->GetMessageId() . '">' . $text . '</a>';
		}
		else
		{
			echo '<em>Subject not accessible</em>';
		}
		echo '</span>';   // .subject

		UnbUi::ShowMsgTags($searchRev, '|tags');
		echo '</div>';   // .subject-line

		$flags = $msg->GetModerationFlags();

		echo '<div class="second-line">';
		echo '<span class="author">';
		echo unbtr('by') . ' <span class="name">' . $msg->GetOwnerUser()->GetDisplayName() . '</span>';
		echo '</span>';

		$msgCreatedTime = $msg->GetCreatedTime();
		echo '<span class="date">';
		UnbUi::RelativeTime($msgCreatedTime);
		echo '</span>';

		UnbUi::MsgRating($msg, 1, 1 /* TODO: Reset to 30 for release */, 30, '|msg-rating');

		list($latestReply, $repliesCount) = $msg->GetLatestReply(true);
		if ($repliesCount)
		{
			echo '<span class="replies">';
			echo unbtr('n replies latest date', $repliesCount, 'time', UnbUi::RelativeTime($latestReply->GetCreatedTime(), true));
			echo '</span>';
		}
		echo '</div>';   // .second-line

		echo '<div class="modwarning">';
		if ($flags & UnbMessageModerationFlag::Hidden)
		{
			echo unbtr('msg:mod.hidden long') . ' &nbsp; ';
		}
		if ($flags & UnbMessageModerationFlag::Locked)
		{
			echo unbtr('msg:mod.locked long') . ' &nbsp; ';
		}
		// If searchRevision != latestRevision, it must be because of a moderation state which is covered below:
		if ($latestRev->GetModerationState() == UnbMessageRevisionModerationState::WaitingForApproval)
		{
			echo unbtr('msg:mod.latest revision waiting for approval long') . ' &nbsp; ';
		}
		else if ($latestRev->GetModerationState() == UnbMessageRevisionModerationState::Locked)
		{
			echo unbtr('msg:mod.latest revision locked long') . ' &nbsp; ';
		}
		echo '</div>';   // .modwarning
		echo '</div>';   // .discussion
	}
}
catch (UnbSecurityException $ex)
{
	UnbUi::ReportError($ex);
}
?>

<?php
require('_foot.inc.php');
?>