<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

UnbUi::BeginReport();
UnbUi::ReportSuccess();
UnbUi::EndReport();
?>

<h1>Tags list</h1>

<?php
function local_ListTags($tags, $parent = 0, $level = 0)
{
	foreach ($tags as $tag)
	{
		if ($tag->GetParentTagId() != $parent) continue;

		echo '<tr><td>';
		echo str_repeat('&nbsp; &nbsp; ', $level);
		echo '<a href="create_tag.php?tagid=' . $tag->GetTagId() . '">' . htmlspecialchars($tag->GetTagName()) . '</a>';
		echo '</td><td>';
		$flagsStr = '';
		if ($tag->GetFlags() & UnbTagFlag::NotSelectable)
			$flagsStr .= ($flagsStr ? ', ' : '') . 'Not selectable';
		if ($tag->GetFlags() & UnbTagFlag::Invisible)
			$flagsStr .= ($flagsStr ? ', ' : '') . 'Invisible';
		if ($tag->GetFlags() & UnbTagFlag::EnforceApproval)
			$flagsStr .= ($flagsStr ? ', ' : '') . 'Enforce approval';
		if ($tag->GetFlags() & UnbTagFlag::UserData)
			$flagsStr .= ($flagsStr ? ', ' : '') . 'With user data';
		if ($flagsStr)
			echo '<small>(' . $flagsStr . ')</small>';
		echo '</td><td>';
		if (strlen($tag->GetDescription()))
		{
			echo htmlspecialchars($tag->GetDescription());
		}
		echo '</td></tr>';

		local_ListTags($tags, $tag->GetTagId(), $level + 1);
	}
}

try
{
	$tags = UnbTag::Find();
	echo '<table cellspacing="0" class="grid">';
	local_ListTags($tags);
	echo '</table>';
}
catch (UnbSecurityException $ex)
{
	UnbUi::ReportError($ex);
}

if (UnbSession::IsModerator())
	echo '<p><a href="create_tag.php" class="buttonlike icon13 create">Create a new tag</a></p>';
?>

<?php
require('_foot.inc.php');
?>