<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

$error = false;
$user = UnbUser::FindByUserId(intval($_REQUEST['userid']));
UnbUi::BeginReport();
if (!isset($user))
{
	UnbUi::ReportError('Invalid user ID');
	$error = true;
}
UnbUi::EndReport();

if (!$error)
{
	?>
	<h1>View user information</h1>

	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td>Display name:</td>
		<td>
			<?php echo htmlspecialchars($user->GetDisplayName()) ?>
		</td>
	</tr>
	<?php
	$logEntries = UnbLog::FindByFilter(array(array(
		'id' => UnbLogEvent::UserDisplayNameChanged,
		'data' => array(
			'userid' => $user->GetUserId(),
			),
		)),
		false,
		true);
	$i = 0;
	foreach (array_reverse($logEntries) as $logEntry)
	{
		echo '<tr>';
		echo '<td>';
		if ($i++ == 0)
			echo 'Previous names:';
		echo '</td>';
		echo '<td>';
		echo htmlspecialchars($logEntry['ParsedData']['oldname']) . ' &nbsp; (until ';
		UnbUi::RelativeTime($logEntry['Time']);
		echo ')';
		echo '</td>';
		echo '</tr>';
	}
	?>
	<tr>
		<td>Creation time:</td>
		<td>
			<?php UnbUi::RelativeTime($user->GetCreatedTime()) ?>
		</td>
	</tr>
	<tr>
		<td>Last login time:</td>
		<td>
			<?php UnbUi::RelativeTime($user->GetLastLoginTime()) ?>
		</td>
	</tr>
	<tr>
		<td>Rating:</td>
		<td>
			<?php
			$rating = $user->GetMessagesRating();
			if ($rating[0] > 0)
				echo round($rating[2], 2) . ' (from ' . $rating[0] . ' ratings with an average weight of ' . round($rating[1] / $rating[0], 1) . ')';
			else
				echo '<em>(No ratings yet)</em>';
			?>
		</td>
	</tr>
	<tr>
		<td>Special privileges:</td>
		<td>
			<?php
			$statusStr = '';
			if ($user->IsAdministrator())
				$statusStr .= ($statusStr ? ', ' : '') . 'Administrator';
			if ($user->IsModerator())
				$statusStr .= ($statusStr ? ', ' : '') . 'Moderator';
			if ($user->IsTrusted())
				$statusStr .= ($statusStr ? ', ' : '') . 'Trusted user';
			if ($statusStr)
				echo $statusStr;
			else
				echo '<em>(None assigned)</em>';
			?>
		</td>
	</tr>
	<tr>
		<td>Additional keys:</td>
		<td>
			<?php
			$additionalKeysList = UnbUi::GetUserAdditionalKeys($user);
			if (strlen($additionalKeysList))
				echo nl2br(htmlspecialchars($additionalKeysList));
			else
				echo '<em>(None assigned)</em>';
			?>
		</td>
	</tr>
	<?php
	$vcardEntries = $user->GetVcardEntries();
	if (count($vcardEntries))
	{
		/*
		?>
		<tr>
			<td colspan="3">
				<h2>VCard entries</h2>
			</td>
		</tr>
		<?php
		*/
		foreach ($vcardEntries as $type => $entry)
		{
			?>
			<tr>
				<td><?php echo htmlspecialchars($type) ?>:</td>
				<td>
					<?php
					echo htmlspecialchars($entry['Data']);
					switch ($entry['Visibility'])
					{
						case UnbUserVcardVisibility::Internal:
							echo ' &nbsp; <small>(Internal)</small>';
							break;
						case UnbUserVcardVisibility::Confidential:
							echo ' &nbsp; <small>(Confidential)</small>';
							break;
						case UnbUserVcardVisibility::Private_:
							echo ' &nbsp; <small>(Private)</small>';
							break;
					}
					?>
				</td>
			</tr>
			<?php
		}
	}
	?>
	</table>

	<?php
}

require('_foot.inc.php');
?>