<?php
// UNB Components Content-Types Compiler
// Copyright 2011 by Yves Goergen
// Website: http://unclassified.de/
// Licence: GNU General Public License (GPL) Version 3
//
// This little script reads the content-types list file and compiles it into PHP code which can
// efficiently access the data.

// ---------- Begin of configuration ----------

$inputFile = 'content-types.txt';
$outputFile = '../unb_lib/unb_content-types.inc.php';

// ---------- End of configuration ----------

// Read file
$lines = file($inputFile);

// Parse file
// (This could as well be used at runtime)
$types = array();
foreach ($lines as $line)
{
	if (preg_match('~^(\S+)\s+([^"]+)\s+"(.*)"(?:\s+(\S+))?$~', trim($line), $m))
	{
		$code = strtolower(trim($m[1]));
		$exts = preg_split('~\s+~', strtolower(trim($m[2])));
		$desc = trim($m[3]);
		$mime = strtolower(trim($m[4]));

		$i = 0;
		foreach ($exts as $ext)
		{
			if ($i == 0)
			{
				$types[$ext] = array($code, $desc, $mime);
				$firstExt = $ext;
			}
			else
			{
				$types[$ext] = $firstExt;
			}
			$i++;
		}
	}
}

// Write file
$fp = fopen($outputFile, 'w');
fwrite($fp, "<?php\n");
fwrite($fp, "\tprivate static \$contentTypes = array(\n");
foreach ($types as $ext => $type)
{
	fwrite($fp, "\t\t'" . $ext . "'=>");
	if (is_array($type))
	{
		fwrite($fp, "array('" . $type[0] . "','" . addslashes($type[1]) . "','" . $type[2] . "'),\n");
	}
	else
	{
		fwrite($fp, "'" . $type . "',\n");
	}
}
fwrite($fp, "\t\t);\n");
fwrite($fp, "?>\n");
fclose($fp);
?>
