<?php
// UNB Components
// Copyright since 2007 by Yves Goergen
// Website: http://unclassified.de/go/unb2
// Licence: GNU General Public License (GPL) Version 3
//
// Database export script

// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
header('Content-Type: text/html; charset=utf-8');

// For security reasons, all configuration must be done statically
// in this source file. There is no web interface for this script.
//
// Configuration should only be required between the lines below:

// ————————————————————————————————————————————————————————————————
// Comment the following line ONLY to enable the script.
// Be sure to undo it as soon as you're done.
#exit();

// Enter the file name to dump the database into:
$fileName = 'unb_dump.txt';

// Include the complete UNB library
require_once('unb_lib/unb_all.lib.php');
// Settings file name is relative to the UNB library source files
UnbUi::Init('../unb_config.inc.php');
// ————————————————————————————————————————————————————————————————

function encode($str)
{
	if (!isset($str))
	{
		return '%NULL';
	}
	$str = str_replace('%', '%25', $str);
	$str = preg_replace('_([\\x00-\\x1F;])_e', '"%" . strtoupper(bin2hex("$1"))', $str);   // like urlencode
	return $str;
}

function write($f, $table, $rec)
{
	fwrite($f, $table);
	foreach ($rec as $val)
	{
		fwrite($f, ';' . encode($val));
	}
	fwrite($f, "\n");
}

function dump($f, $table)
{
	$columns = '';
	for ($i = 2; $i < func_num_args(); $i++)
	{
		$columns .= ($columns ? ', ' : '') .
			'"' . func_get_arg($i) . '"';
	}

	foreach (UnbDatabase::GetInstance()->Query('SELECT ' . $columns . ' FROM "#' . $table . '"') as $rec)
	{
		write($f, $table, $rec);
	}
}

// Do the job...
$f = fopen($fileName, 'w');

dump($f, 'keylist', 'KeylistId');

dump($f, 'keylist_keys', 'KeylistId', 'UserId');

dump($f, 'user', 'UserId', 'CreatedTime', 'LastLoginTime', 'DisplayName', 'AdditionalKeylistId', 'LoginName', 'LoginPassword');

dump($f, 'user_vcard', 'UserId', 'Type', 'Data', 'Visibility');

dump($f, 'user_config', 'UserId', 'Name', 'Data');

dump($f, 'message', 'MessageId', 'CreatedTime', 'Owner', 'PrimaryReference', 'EntryPoint', 'PageName', 'Draft', 'ReadAccessKeylistId', 'AlterAccessKeylistId', 'ReplyAccessKeylistId', 'ModerationFlags', 'FileType', 'SearchOptimisedContent', 'SearchOptimisedSubject', 'SearchRevisionId', 'LastBeginEdit');

dump($f, 'message_reference', 'MessageId', 'Reference');

dump($f, 'message_revision', 'MessageRevisionId', 'MessageId', 'CreatedTime', 'Author', 'Subject', 'Content', /*'HtmlContent',*/ 'Summary', 'ModerationState', 'Draft', 'ContentType', 'Data');

dump($f, 'tag', 'TagId', 'TagName', 'ParentTag', 'Meaning', 'Description', 'UseAccessKeylistId', 'ReadAccessKeylistId', 'Flags');

dump($f, 'message_revision_tag', 'MessageRevisionId', 'TagId', 'TagData');

dump($f, 'message_revision_file', 'MessageRevisionId', 'MessageId', 'Relation');

dump($f, 'message_rating', 'UserId', 'MessageId', 'Rating', 'Weight');

fclose($f);

echo 'Export complete.';
?>