<?php
// UNB Components
// Copyright since 2007 by Yves Goergen
// Website: http://unclassified.de/go/unb2
// Licence: GNU General Public License (GPL) Version 3
//
// This file contains global functions for easier access to UNB class methods. Its inclusion is
// entirely optional. The functions defined in this file are not used by the UNB classes
// themselves but are only intended for applications using the UNB API. This means that single
// functions can safely be renamed in case of a name conflict.

// Calls UnbLocale::Translate.
//
// See its description for parameters and return value.
//
function unbtr()
{
	return call_user_func_array(array('UnbLocale', 'Translate'), func_get_args());
}

// Calls UnbLocale::Translate and passes its return value to UnbLocale::Capital.
//
// See its description for parameters and return value.
//
function unbtrc()
{
	return UnbLocale::Capital(call_user_func_array(array('UnbLocale', 'Translate'), func_get_args()));
}

// Calls UnbLocale::Capital.
//
// See its description for parameters and return value.
//
function unbcap($str)
{
	return UnbLocale::Capital($str);
}

// Calls UnbLocale::Quote.
//
// See its description for parameters and return value.
//
function unbqt($str)
{
	return UnbLocale::Quote($str);
}

// Calls UnbLocale::Parentheses.
//
// See its description for parameters and return value.
//
function unbpar($str)
{
	return UnbLocale::Parentheses($str);
}

// Calls UnbLocale::Colon.
//
// See its description for parameters and return value.
//
function unbcol()
{
	return UnbLocale::Colon();
}

// Calls UnbLocale::Time with the HTML option.
//
// See its description for parameters and return value.
//
function unbtm($timestamp, $details = UnbTimeFormat::DateTime)
{
	return UnbLocale::Time($timestamp, $details, true);
}

// Calls UnbLocale::Number with the HTML option.
//
// See its description for parameters and return value.
//
function unbnum($number, $decimals = 0)
{
	return UnbLocale::Number($number, $decimals, true);
}

// Calls UnbLocale::DataSize with the HTML option.
//
// See its description for parameters and return value.
//
function unbds($size)
{
	return UnbLocale::DataSize($size, true);
}

?>
