<?php
// UNB Components
// Copyright since 2007 by Yves Goergen
// Website: http://unclassified.de/go/unb2
// Licence: GNU General Public License (GPL) Version 3
//
// This file contains the UNB locale de-DE class.

// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)

if (!class_exists('UnbLocale', false)) require_once dirname(__FILE__) . '/../locale.class.php';

// de-DE locale class.
//
class UnbLocale_de_DE extends UnbLocale
{
	// Locale code.
	protected $code = 'de-DE';

	// Locale importance for its language, used to sort known locales when only a language is requested.
	// This should be roughly the number of people affected by the locale, divided by 1000.
	protected $importance = 77000;   // Source: http://de.wikipedia.org/wiki/Deutsche_Sprache#Verbreitung_der_deutschen_Sprache_weltweit

	// Starting quotation mark.
	protected $quoteStart = '„';

	// Ending quotation mark.
	protected $quoteEnd = '“';

	// Colon.
	protected $colon = ':';

	// The text dictionary.
	protected $dict = array(
		'access:default everybody click to add' => 'Jeder – hier klicken, um Benutzer anzugeben',
		'access:default everybody' => 'Jeder',
		'exception:BadMethodCallException' => 'Ungültiger Methodenaufruf',
		'exception:Exception' => 'Fehler',
		'exception:InvalidArgumentException' => 'Ungültiger Parameter',
		'exception:LengthException' => 'Falsche Länge',
		'exception:UnbDatabaseException' => 'Datenbankfehler',
		'exception:UnbSecurityException' => 'Sicherheitsfehler',
		'format:code' => 'Quelltext',
		'format:emphasis' => 'Hervorheben',
		'format:indentation' => 'Einrücken',
		'format:list' => 'Aufzählung',
		'format:ordered list' => 'Numm. Aufzählung',
		'format:quotation' => 'Zitat',
		'format:strike' => 'Durchstreichen',
		'format:strong emphasis' => 'Stark hervorh.',
		'format:web link' => 'Web-Verweis',
		'msg:average rating' => 'Durchschnittliche Bewertung: {rating} (aus {count} Bewertungen)',
		'msg:captcha 1' => 'Bitte geben Sie das Wort aus dem<br />Bild in das Feld darunter ein.',
		'msg:captcha 2' => 'Nur die Buchstaben eingeben, Kleinschreibung ist in Ordnung.',
		'msg:dep option' => 'Diese Mitteilung beginnt ein neues Thema.',
		'msg:enforce approval' => 'Genehmigung aller Antworten auf diese Mitteilung erforderlich',
		'msg:formatting learn mode' => 'Erfahren Sie mehr über die PlainType-Formatierungssprache…',
		'msg:hidden' => 'versteckt',
		'msg:hide this message' => 'Diese Mitteilung verstecken',
		'msg:lock this message' => 'Diese Mitteilung sperren',
		'msg:locked' => 'gesperrt',
		'msg:more replies' => '{#} weitere Antworten',
		'msg:more replies#1' => 'eine weitere Antwort',
		'msg:no reply' => 'keine Antwort',
		'msg:page redirection' => 'Seiten-Weiterleitung',
		'msg:page redirection click here' => 'Klicken Sie hier, falls die Weiterleitung in Ihrem Browser deaktiviert ist.',
		'msg:problem processing request' => 'Entschuldigung, bei der Verarbeitung Ihrer Eingaben ist ein Fehler aufgetreten.',
		'msg:quote header' => '{user} schrieb {time}',
		'msg:references' => '{#} Referenzen',
		'msg:references#1' => 'eine Referenz',
		'msg:remove this file' => 'Diese Datei entfernen',
		'msg:text formatting header' => 'Textformatierung und -strukturierung',
		'msg:unapproved' => 'ungenehmigt',
		'tag:enforce approval' => 'Genehmigung aller Antworten erforderlich',
		'tag:invisible' => 'unsichtbar',
		'tag:none' => 'keines',
		'tag:not allowed tip' => 'Sie sind nicht berechtigt, dieses Tag zu benutzen.',
		'tag:not selectable' => 'nicht auswählbar',
		'tag:not selectable tip' => 'Dieses Tag ist nicht auswählbar.',
		'tag:user data' => 'mit Benutzerdaten',
		'user:administrator' => 'Administrator',
		'user:moderator' => 'Moderator',
		'user:reset auto-login password' => 'Kennwort zur automatischen Anmeldung zurücksetzen',
		'user:trusted' => 'Vertrauenswürdiger Benutzer',
		'user-vcard:confidential' => 'Vertraulich',
		'user-vcard:internal' => 'Intern',
		'user-vcard:private' => 'Privat',
		'user-vcard:public' => 'Öffentlich',
		'user-vcard:remove this entry' => 'Diesen Eintrag entfernen',
		'user-vcard:visibility' => 'Sichtbarkeit',

		'markup:off topic' => 'Off Topic:',
		'markup:google web search' => '(Google-Websuche)',
		'markup:google web search link' => 'http://www.google.de/search?&q={q}',
		'markup:wikipedia' => '(Wikipedia)',
		'markup:wikipedia link' => 'http://de.wikipedia.org/wiki/Spezial:Suche?go=Artikel&search={q}',

		'error:2' => 'Der Seitenname ist zu lang.',
		'error:3' => 'Der Inhalt ist zu lang.',
		'error:4' => 'Der Betreff ist zu lang.',
		'error:5' => 'Die Zusammenfassung ist zu lang.',
		'error:11' => 'Die Tag-Daten sind zu lang.',
		'error:12' => 'Sie können sich nicht ohne ein Kennwort anmelden.',
		'error:13' => 'Das angegebene Anmeldekennwort wurde nicht akzeptiert.',
		'error:14' => 'Der Tag-Name ist zu lang.',
		'error:15' => 'Die Beschreibung ist zu lang.',
		'error:16' => 'Der Anzeigename ist zu lang.',
		'error:17' => 'Der Anmeldename ist zu lang.',
		'error:18' => 'Either both login name and password or none at all must be set.',   // TODO
		'error:19' => 'Das Anmeldekennwort wird nicht als sicher angesehen.',
		'error:20' => 'Der Anzeigename ist bereits vergeben.',
		'error:21' => 'Der Anmeldename ist bereits vergeben.',
		'error:23' => 'Benutzer-vCard-Typname ist zu lang.',
		'error:24' => 'Benutzer-vCard-Daten sind zu lang.',
		'error:27' => 'Kein Anmeldename angegeben.',
		'error:28' => 'Kein Anmeldekennwort angegeben.',
		'error:29' => 'Kein Benutzer-Anzeigename angegeben.',
		'error:30' => 'Falsche Wiederholung des Kennworts.',
		'error:31' => 'Falsches Prüfungswort.',
		'error:32' => 'Der Anmeldename ist unbekannt.',
		'error:33' => 'Kein Mitteilungstext angegeben.',
		'error:34' => 'Falsches aktuelles Kennwort.',
		'error:35' => 'Benutzer-ID {id} ist ungültig.',
		'error:36' => 'Benutzer-ID {id} ist unbekannt.',
		'error:40' => 'Benutzername {name} ist unbekannt.',

		'error:password security.too short' => 'Mindestens 6 Zeichen erforderlich.',
		'error:password security.equals username' => 'Kennwort darf nicht gleich dem Benutzernamen sein.',
		'error:password security.contains username' => 'Kennwort darf den Benutzernamen nicht enthalten.',
		'error:password security.non ascii' => 'Nur ASCII-Zeichen zulässig.',
		'error:password security.character classes' => 'Mindestens 2 Zeichenklassen aus Zahlen, Kleinbuchstaben, Großbuchstaben und anderen Zeichen erforderlich.',
		'error:password security.repeated character' => 'Kein Zeichen darf 3 mal oder öfter wiederholt werden.',
		'error:password security.simple sequences' => 'Einfache Folgen wie 123 oder abc sind unzulässig.',
		'error:password security.different characters' => 'Mindestens 4 unterschiedliche Zeichen erforderlich.',

		'empty' => 'empty',
		'unit:bytes' => '{#} Bytes',
		'unit:bytes#1' => 'ein Byte',

		'contenttype:unknown' => 'unbekannter Dateityp',
		'contenttype:application/adobe.flash' => 'Adobe-Flash-Anwendung',
		'contenttype:application/java-class' => 'Java-Bytecode-Klasse',
		'contenttype:application/ms.installer' => 'Microsoft-Installationspaket',
		'contenttype:application/ms.script' => 'Microsoft-Skriptanwendung',
		'contenttype:application/ms.windows' => 'Microsoft-Windows-Anwendung',
		'contenttype:application/sh' => 'Shellskript-Anwendung',
		'contenttype:archive/7zip' => '7-Zip-Archiv',
		'contenttype:archive/android-package' => 'Android-Anwendungspaket',
		'contenttype:archive/bzip' => 'BZip-Archiv',
		'contenttype:archive/bzip2' => 'BZip2-Archiv',
		'contenttype:archive/cpio' => 'CPIO-Archiv',
		'contenttype:archive/debian-package' => 'Debian-Paket',
		'contenttype:archive/gzip' => 'GZip-Archiv',
		'contenttype:archive/jar' => 'Java-Archiv',
		'contenttype:archive/lzma' => 'LZMA-Archiv',
		'contenttype:archive/mozilla.xpinstall' => 'Mozilla-Add-on',
		'contenttype:archive/ms.cab' => 'Microsoft-Cabinet-Archiv',
		'contenttype:archive/rar' => 'RAR-Archiv',
		'contenttype:archive/tar' => 'TAR-Archiv',
		'contenttype:archive/zip' => 'ZIP-Archiv',
		'contenttype:audio/aac' => 'AAC audio',
		'contenttype:audio/ac3' => 'AC3 audio',
		'contenttype:audio/aiff' => 'AIFF audio',
		'contenttype:audio/midi' => 'MIDI audio',
		'contenttype:audio/mpeg' => 'MPEG audio',
		'contenttype:audio/mpeg4' => 'MPEG4 audio',
		'contenttype:audio/ms.wma' => 'Microsoft Windows Media audio',
		'contenttype:audio/ogg' => 'Ogg audio',
		'contenttype:audio/real' => 'Real audio',
		'contenttype:audio/wave' => 'WAVE audio',
		'contenttype:document/config' => 'Text-Konfigurationsdatei',
		'contenttype:document/csv' => 'Komma-getrennte Werte',
		'contenttype:document/diff' => 'Unified-Diff-Datei',
		'contenttype:document/email' => 'E-Mail-Dokument',
		'contenttype:document/ms.access' => 'Microsoft-Access-Datenbank',
		'contenttype:document/ms.excel' => 'Microsoft-Excel-Dokument',
		'contenttype:document/ms.htmlhelp' => 'Microsoft-HTML-Hilfe',
		'contenttype:document/ms.powerpoint' => 'Microsoft-PowerPoint-Präsentation',
		'contenttype:document/ms.visio' => 'Microsoft-Visio-Dokument',
		'contenttype:document/ms.word' => 'Microsoft-Word-Dokument',
		'contenttype:document/ms.word-template' => 'Microsoft-Word-Dokumentvorlage',
		'contenttype:document/ms.write' => 'Microsoft-Write-Dokument',
		'contenttype:document/ms.xps' => 'Microsoft-XPS-Dokument',
		'contenttype:document/oasis.chart' => 'OpenDocument-Diagramm',
		'contenttype:document/oasis.chart-template' => 'OpenDocument-Diagrammvorlage',
		'contenttype:document/oasis.database' => 'OpenDocument-Datenbank',
		'contenttype:document/oasis.formula' => 'OpenDocument formula',
		'contenttype:document/oasis.formula-template' => 'OpenDocument formula template',
		'contenttype:document/oasis.graphics' => 'OpenDocument-Zeichnung',
		'contenttype:document/oasis.presentation' => 'OpenDocument-Präsentation',
		'contenttype:document/oasis.presentation-template' => 'OpenDocument-Präsentationsvorlage',
		'contenttype:document/oasis.spreadsheet' => 'OpenDocument-Tabelle',
		'contenttype:document/oasis.spreadsheet-template' => 'OpenDocument-Tabellenvorlage',
		'contenttype:document/oasis.text' => 'OpenDocument-Text',
		'contenttype:document/oasis.text-master' => 'OpenDocument-Textmaster',
		'contenttype:document/oasis.text-template' => 'OpenDocument-Textvorlage',
		'contenttype:document/pdf' => 'Adobe-PDF-Dokument',
		'contenttype:document/plaintext' => 'Klartext',
		'contenttype:document/postscript' => 'PostScript-Dokument',
		'contenttype:document/rtf' => 'Rich-Text-Dokument',
		'contenttype:document/sun-staroffice.calc' => 'Sun StarOffice Calc document',
		'contenttype:document/sun-staroffice.draw' => 'Sun StarOffice Draw document',
		'contenttype:document/sun-staroffice.impress' => 'Sun StarOffice Impress presentation',
		'contenttype:document/sun-staroffice.writer' => 'Sun StarOffice Writer document',
		'contenttype:document/tex' => 'TeX-Document',
		'contenttype:document/vcalendar' => 'vCalendar-Datei',
		'contenttype:document/vcard' => 'vCard-Datei',
		'contenttype:document/wordperfect' => 'WordPerfect-Dokument',
		'contenttype:document/x509-cert' => 'X.509-Zertifikat',
		'contenttype:document/xml' => 'XML-Dokument',
		'contenttype:font/ms.eot' => 'Microsoft-Webschriftart',
		'contenttype:font/opentype' => 'OpenType-Schriftart',
		'contenttype:font/truetype' => 'TrueType-Schriftart',
		'contenttype:font/type1' => 'Type1-Schriftart',
		'contenttype:generic/google.earth-kml' => 'Google Earth KML',
		'contenttype:generic/google.earth-kmz' => 'Google Earth KMZ',
		'contenttype:generic/pgp-encrypted' => 'PGP-verschlüsselte Datei',
		'contenttype:generic/pgp-signature' => 'PGP-Signatur',
		'contenttype:image/adobe.dng' => 'Adobe digitales Negativ',
		'contenttype:image/adobe.photoshop' => 'Adobe-Photoshop-Bild',
		'contenttype:image/bitmap' => 'Bitmap-Bild',
		'contenttype:image/gif' => 'GIF-Bild',
		'contenttype:image/jpeg' => 'JPEG-Bild',
		'contenttype:image/jpeg2000' => 'JPEG2000-Bild',
		'contenttype:image/ms.icon' => 'Microsoft-Symbol-Bild',
		'contenttype:image/ms.wmf' => 'Microsoft Windows Metafile Zeichnung',
		'contenttype:image/png' => 'PNG-Bild',
		'contenttype:image/svg' => 'SVG-Zeichnung',
		'contenttype:image/tiff' => 'TIFF-Bild',
		'contenttype:image/xbitmap' => 'X bitmap image',
		'contenttype:image/xpixmap' => 'X pixmap image',
		'contenttype:source/asm' => 'Assembler-Quelltext',
		'contenttype:source/basic' => 'BASIC-Quelltext',
		'contenttype:source/c' => 'C/C++-Quelltext',
		'contenttype:source/c-header' => 'C/C++-Quelltextheader',
		'contenttype:source/cpp' => 'C/C++-Quelltext',
		'contenttype:source/cpp-header' => 'C/C++-Quelltextheader',
		'contenttype:source/csharp' => 'C#-Quelltext',
		'contenttype:source/css' => 'Cascading stylesheet',
		'contenttype:source/html' => 'HTML-Quelltext',
		'contenttype:source/java' => 'Java-Quelltext',
		'contenttype:source/javascript' => 'JavaScript-Quelltext',
		'contenttype:source/ms.visual-basic' => 'Visual-Basic-Quelltext',
		'contenttype:source/pascal' => 'Pascal-Quelltext',
		'contenttype:source/perl' => 'Perl-Quelltext',
		'contenttype:source/php' => 'PHP-Quelltext',
		'contenttype:source/python' => 'Python-Quelltext',
		'contenttype:source/ruby' => 'Ruby-Quelltext',
		'contenttype:source/wsdl' => 'WSDL-Quelltext',
		'contenttype:source/xaml' => 'XAML-Quelltext',
		'contenttype:source/xhtml' => 'XHTML-Webseite',
		'contenttype:source/xml-dtd' => 'XML document type definition',
		'contenttype:source/xsd' => 'XML-Schema',
		'contenttype:source/xsl' => 'XML-Stylesheet',
		'contenttype:source/xslt' => 'XSL transformation file',
		'contenttype:source/xul' => 'Mozilla-XUL-Quelltext',
		'contenttype:video/3gpp' => '3GPP-Video',
		'contenttype:video/apple.quicktime' => 'Apple-QuickTime-Video',
		'contenttype:video/h264' => 'H.264-Video',
		'contenttype:video/mjp2' => 'MJP2-Video',
		'contenttype:video/mpeg' => 'MPEG-Video',
		'contenttype:video/mpeg4' => 'MPEG4-Video',
		'contenttype:video/ms.asf' => 'Microsoft-ASF-Video',
		'contenttype:video/ms.avi' => 'Microsoft-AVI-Video',
		'contenttype:video/ms.vc1' => 'Microsoft-VC-1-Video',
		'contenttype:video/ms.wmv' => 'Microsoft-Windows-Media-Video',
		'contenttype:video/ogg' => 'Ogg-Video',

		'time:none' => 'keine Zeit',
		'time:never' => 'nie',
		'time:now' => 'jetzt',
		'time:combine' => ' und ',
		'time:pattern point past' => 'vor {time}',
		'time:pattern point future' => 'in {time}',
		'time:pattern span past' => 'seit {time}',
		'time:pattern span future' => 'für {time}',
		'time:pattern before past' => '{time} zuvor',
		'time:pattern before future' => '{time} später',
		'time.1:years' => '{#} Jahre',
		'time.1:years#1' => 'ein Jahr',
		'time.1:months' => '{#} Monate',
		'time.1:months#1' => 'einen Monat',
		'time.1:days' => '{#} Tage',
		'time.1:days#1' => 'einen Tag',
		'time.1:hours' => '{#} Stunden',
		'time.1:hours#1' => 'eine Stunde',
		'time.1:minutes' => '{#} Minuten',
		'time.1:minutes#1' => 'eine Minute',
		'time.1:seconds' => '{#} Sekunden',
		'time.1:seconds#1' => 'eine Sekunde',
		'time.2:years' => '{#} Jahren',
		'time.2:years#1' => 'einem Jahr',
		'time.2:months' => '{#} Monaten',
		'time.2:months#1' => 'einem Monat',
		'time.2:days' => '{#} Tagen',
		'time.2:days#1' => 'einem Tag',
		'time.2:hours' => '{#} Stunden',
		'time.2:hours#1' => 'einer Stunde',
		'time.2:minutes' => '{#} Minuten',
		'time.2:minutes#1' => 'einer Minute',
		'time.2:seconds' => '{#} Sekunden',
		'time.2:seconds#1' => 'einer Sekunde',
		'timezone:CET' => 'MEZ',
		'timezone:CEST' => 'MESZ',
		'month:1' => 'Januar',
		'month:2' => 'Februar',
		'month:3' => 'März',
		'month:4' => 'April',
		'month:5' => 'Mai',
		'month:6' => 'Juni',
		'month:7' => 'Juli',
		'month:8' => 'August',
		'month:9' => 'September',
		'month:10' => 'Oktober',
		'month:11' => 'November',
		'month:12' => 'Dezember',
		'weekday:1' => 'Mo',
		'weekday:2' => 'Di',
		'weekday:3' => 'Mi',
		'weekday:4' => 'Do',
		'weekday:5' => 'Fr',
		'weekday:6' => 'Sa',
		'weekday:7' => 'So',
		'weekdaylong:1' => 'Montag',
		'weekdaylong:2' => 'Dienstag',
		'weekdaylong:3' => 'Mittwoch',
		'weekdaylong:4' => 'Donnerstag',
		'weekdaylong:5' => 'Freitag',
		'weekdaylong:6' => 'Samstag',
		'weekdaylong:7' => 'Sonntag',
		);

	public function __construct()
	{
		// Add more translations that PHP doesn't understand in the static initialiser

		$this->dict['logevent:' . UnbLogEvent::UserLogin] = 'Benutzer hat sich erfolgreich angemeldet';
		$this->dict['logevent:' . UnbLogEvent::UserLogout] = 'Benutzer hat sich abgemeldet';
		$this->dict['logevent:' . UnbLogEvent::UserLoginFailed] = 'Benutzer hat erfolglos versucht, sich anzumelden';

		$this->dict['logevent:' . UnbLogEvent::UserDisplayNameChanged] = 'Anzeigename der Benutzers wurde geändert';

		$this->dict['logevent:' . UnbLogEvent::MessageRevisionApproved] = 'Mitteilungsrevision genehmigt';
		$this->dict['logevent:' . UnbLogEvent::MessageRevisionLocked] = 'Mitteilungsrevision gesperrt';
		$this->dict['logevent:' . UnbLogEvent::MessageRevisionUnlocked] = 'Mitteilungsrevision entsperrt';
		$this->dict['logevent:' . UnbLogEvent::MessageLocked] = 'Mitteilung gesperrt';
		$this->dict['logevent:' . UnbLogEvent::MessageUnlocked] = 'Mitteilung entsperrt';
		$this->dict['logevent:' . UnbLogEvent::MessageHidden] = 'Mitteilung versteckt';
		$this->dict['logevent:' . UnbLogEvent::MessageUnhidden] = 'Message unhidden';   // TODO
	}

	protected function FormatNumber($number, $decimals, $html)
	{
		return number_format($number, $decimals, ',', '.');
	}

	protected function FormatOrdinalNumber($number, $html)
	{
		return $number . '.';
	}

	protected function FormatTime($datetime, $details, $html)
	{
		$sp = "\xC2\xA0";   // "\xC2\xA0" = utf8_encode("\xA0")

		$str = '';

		if ($details & UnbTimeFormat::Weekday)   // Mo
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('weekday:' . $datetime->format('N')) .
				($details & ~UnbTimeFormat::Weekday ? ',' : '');
		}
		else if ($details & UnbTimeFormat::WeekdayLong)   // Montag
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('weekdaylong:' . $datetime->format('N')) .
				($details & ~UnbTimeFormat::WeekdayLong ? ',' : '');
		}

		if ($details & UnbTimeFormat::Date)   // 01.01.2000
		{
			$str .= (strlen($str) ? $sp : '') .
				$datetime->format('d.m.Y');
			$haveDate = true;
		}
		else if ($details & UnbTimeFormat::DateLong)   // 1. Januar 2000
		{
			$str .= (strlen($str) ? $sp : '') .
				$datetime->format('j.') . $sp .
				UnbLocale::Translate('month:' . $datetime->format('n')) . $sp .
				$datetime->format('Y');
			$haveDate = true;
		}

		if ($details & UnbTimeFormat::TimeSec)   // 12:15:00
		{
			$str .= (strlen($str) ? ($haveDate && $html ? $sp . $sp : $sp) : '') .
				$datetime->format('H:i:s');
		}
		else if ($details & UnbTimeFormat::Time)   // 12:15
		{
			$str .= (strlen($str) ? ($haveDate && $html ? $sp . $sp : $sp) : '') .
				$datetime->format('H:i');
		}

		if ($details & UnbTimeFormat::TimeZone)   // MEZ
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('timezone:' . $datetime->format('T'), true);
		}

		return $str;
	}

	protected function FormatRelativeTime($diff, $context, $html)
	{
		switch ($context)
		{
			case UnbTimeContext::Point:
				if ($diff->invert)   // vor 2 Jahren
					$grammar = 2;
				else   // in 2 Jahren
					$grammar = 2;
				break;

			case UnbTimeContext::Span:
				if ($diff->invert)   // seit 2 Jahren
					$grammar = 2;
				else   // für 2 Jahre
					$grammar = 1;
				break;

			case UnbTimeContext::Before:
				if ($diff->invert)   // 2 Jahre zuvor
					$grammar = 1;
				else   // 2 Jahre später
					$grammar = 1;
				break;
		}

		$parts = array();
		if ($diff->y && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':years', $diff->y));
		if ($diff->m && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':months', $diff->m));
		if ($diff->d && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':days', $diff->d));
		if ($diff->h && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':hours', $diff->h));
		if ($diff->i && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':minutes', $diff->i));
		if ($diff->s && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':seconds', $diff->s));

		$str = '';
		foreach ($parts as $part)
		{
			$str .= (strlen($str) ? UnbLocale::Translate('time:combine') : '') .
				$part;
		}

		switch ($context)
		{
			case UnbTimeContext::Point:
				if ($diff->invert)   // vor 2 Jahren
					$str = self::Translate('time:pattern point past', 'time', $str);
				else   // in 2 Jahren
					$str = self::Translate('time:pattern point future', 'time', $str);
				break;

			case UnbTimeContext::Span:
				if ($diff->invert)   // seit 2 Jahren
					$str = self::Translate('time:pattern span past', 'time', $str);
				else   // für 2 Jahre
					$str = self::Translate('time:pattern span future', 'time', $str);
				break;

			case UnbTimeContext::Before:
				if ($diff->invert)   // 2 Jahre zuvor
					$str = self::Translate('time:pattern before past', 'time', $str);
				else   // 2 Jahre später
					$str = self::Translate('time:pattern before future', 'time', $str);
				break;
		}
		return $str;
	}

}

// Automatically register this locale
UnbLocale::Register(new UnbLocale_de_DE());

?>
