<?php
// UNB Components
// Copyright since 2007 by Yves Goergen
// Website: http://unclassified.de/go/unb2
// Licence: GNU General Public License (GPL) Version 3
//
// This file contains the UNB locale en-US class.

// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)

if (!class_exists('UnbLocale', false)) require_once dirname(__FILE__) . '/../locale.class.php';

// en-US locale class.
//
class UnbLocale_en_US extends UnbLocale
{
	// Locale code.
	protected $code = 'en-US';

	// Locale importance for its language, used to sort known locales when only a language is requested.
	// This should be roughly the number of people affected by the locale, divided by 1000.
	protected $importance = 251000;   // Source: http://en.wikipedia.org/wiki/English_language#Countries_in_order_of_total_speakers

	// Starting quotation mark.
	protected $quoteStart = '“';

	// Ending quotation mark.
	protected $quoteEnd = '”';

	// Colon.
	protected $colon = ':';

	// The text dictionary.
	protected $dict = array(
		'access:default everybody click to add' => 'Everybody – click here to specify users',
		'access:default everybody' => 'Everybody',
		'exception:BadMethodCallException' => 'Bad method call',
		'exception:Exception' => 'Error',
		'exception:InvalidArgumentException' => 'Invalid argument',
		'exception:LengthException' => 'Length error',
		'exception:UnbDatabaseException' => 'Database error',
		'exception:UnbSecurityException' => 'Security error',
		'format:code' => 'Code',
		'format:emphasis' => 'Emphasis',
		'format:indentation' => 'Indentation',
		'format:list' => 'List',
		'format:ordered list' => 'Ordered list',
		'format:quotation' => 'Quotation',
		'format:strike' => 'Strike',
		'format:strong emphasis' => 'Strong emphasis',
		'format:web link' => 'Web link',
		'msg:average rating' => 'Average rating: {rating} (from {count} ratings)',
		'msg:captcha 1' => 'Please type all the <strong>letters only</strong> of the word<br />from the image into the text field below.',
		'msg:captcha 2' => 'Letters go in here: &nbsp; (Lower case is okay.)',
		'msg:dep option' => 'This message starts a new topic.',
		'msg:enforce approval' => 'Enforce approval of all replies to this message',
		'msg:formatting learn mode' => 'Learn more about the PlainType markup language…',
		'msg:hidden' => 'hidden',
		'msg:hide this message' => 'Hide this message',
		'msg:lock this message' => 'Lock this message',
		'msg:locked' => 'locked',
		'msg:more replies' => '{#} more replies',
		'msg:more replies#1' => 'one more reply',
		'msg:no reply' => 'no reply',
		'msg:page redirection' => 'Page redirection',
		'msg:page redirection click here' => 'Click here if redirection is disabled in your browser.',
		'msg:problem processing request' => 'Sorry, there was a problem processing your request.',
		'msg:quote header' => '{user} wrote {time}',
		'msg:references' => '{#} references',
		'msg:references#1' => 'one reference',
		'msg:remove this file' => 'Remove this file',
		'msg:text formatting header' => 'Text formatting and structuring',
		'msg:unapproved' => 'unapproved',
		'tag:enforce approval' => 'enforce approval of all replies',
		'tag:invisible' => 'invisible',
		'tag:none' => 'none',
		'tag:not allowed tip' => 'You are not allowed to use this tag.',
		'tag:not selectable' => 'not selectable',
		'tag:not selectable tip' => 'This tag is not selectable.',
		'tag:user data' => 'with user data',
		'user:administrator' => 'Administrator',
		'user:moderator' => 'Moderator',
		'user:reset auto-login password' => 'Reset auto-login password',
		'user:trusted' => 'Trusted user',
		'user-vcard:confidential' => 'Confidential',
		'user-vcard:internal' => 'Internal',
		'user-vcard:private' => 'Private',
		'user-vcard:public' => 'Public',
		'user-vcard:remove this entry' => 'Remove this entry',
		'user-vcard:visibility' => 'Visibility',

		'markup:off topic' => 'Off Topic:',
		'markup:google web search' => '(Google Web Search)',
		'markup:google web search link' => 'http://www.google.com/search?&q={q}',
		'markup:wikipedia' => '(Wikipedia)',
		'markup:wikipedia link' => 'http://en.wikipedia.org/wiki/Special:Search?search={q}',

		'error:2' => 'Page name is too long.',
		'error:3' => 'Content is too long.',
		'error:4' => 'Subject is too long.',
		'error:5' => 'Summary is too long.',
		'error:11' => 'Tag data is too long.',
		'error:12' => 'You cannot log in without a password.',
		'error:13' => 'The login password you provided was rejected.',
		'error:14' => 'Tag name is too long.',
		'error:15' => 'Description is too long.',
		'error:16' => 'Display name is too long.',
		'error:17' => 'Login name is too long.',
		'error:18' => 'Either both login name and password or none at all must be set.',
		'error:19' => 'Login password is not considered secure.',
		'error:20' => 'Display name is already assigned.',
		'error:21' => 'Login name is already assigned.',
		'error:23' => 'User vCard type is too long.',
		'error:24' => 'User vCard data is too long.',
		'error:27' => 'No user login name specified.',
		'error:28' => 'No user login password specified.',
		'error:29' => 'No user display name specified.',
		'error:30' => 'Incorrect password repetition.',
		'error:31' => 'Incorrect verification word.',
		'error:32' => 'Login name is unknown.',
		'error:33' => 'No message content specified.',
		'error:34' => 'Incorrect current password.',
		'error:35' => 'User ID {id} is invalid.',
		'error:36' => 'User ID {id} is unknown.',
		'error:40' => 'User name {name} is unknown.',

		'error:password security.too short' => 'At least 6 characters required.',
		'error:password security.equals username' => 'Password must not be equal to the username.',
		'error:password security.contains username' => 'Password must not contain the username.',
		'error:password security.non ascii' => 'Only ASCII characters are allowed.',
		'error:password security.character classes' => 'At least 2 character classes out of numbers, lowercase, uppercase characters and other symbols required.',
		'error:password security.repeated character' => 'No character may be repeated 3 times or more.',
		'error:password security.simple sequences' => 'Simple sequences like 123 or abc are not allowed.',
		'error:password security.different characters' => 'At least 4 different characters must be used.',

		'empty' => 'empty',
		'unit:bytes' => '{#} bytes',
		'unit:bytes#1' => 'one byte',

		'contenttype:unknown' => 'unknown content type',

		'time:none' => 'no time',
		'time:never' => 'never',
		'time:now' => 'now',
		'time:combine' => ' and ',
		'time:pattern point past' => '{time} ago',
		'time:pattern point future' => 'in {time}',
		'time:pattern span past' => 'for {time}',
		'time:pattern span future' => 'for {time}',
		'time:pattern before past' => '{time} before',
		'time:pattern before future' => '{time} later',
		'time.1:years' => '{#} years',
		'time.1:years#1' => 'one year',
		'time.1:months' => '{#} months',
		'time.1:months#1' => 'one month',
		'time.1:days' => '{#} days',
		'time.1:days#1' => 'one day',
		'time.1:hours' => '{#} hours',
		'time.1:hours#1' => 'one hour',
		'time.1:minutes' => '{#} minutes',
		'time.1:minutes#1' => 'one minute',
		'time.1:seconds' => '{#} seconds',
		'time.1:seconds#1' => 'one second',
		'month:1' => 'January',
		'month:2' => 'February',
		'month:3' => 'March',
		'month:4' => 'April',
		'month:5' => 'May',
		'month:6' => 'June',
		'month:7' => 'July',
		'month:8' => 'August',
		'month:9' => 'September',
		'month:10' => 'October',
		'month:11' => 'November',
		'month:12' => 'December',
		'weekday:1' => 'Mon',
		'weekday:2' => 'Tue',
		'weekday:3' => 'Wed',
		'weekday:4' => 'Thu',
		'weekday:5' => 'Fri',
		'weekday:6' => 'Sat',
		'weekday:7' => 'Sun',
		'weekdaylong:1' => 'Monday',
		'weekdaylong:2' => 'Tuesday',
		'weekdaylong:3' => 'Wednesday',
		'weekdaylong:4' => 'Thursday',
		'weekdaylong:5' => 'Friday',
		'weekdaylong:6' => 'Saturday',
		'weekdaylong:7' => 'Sunday',
		);

	public function __construct()
	{
		// Add more translations that PHP doesn't understand in the static initialiser

		$this->dict['logevent:' . UnbLogEvent::UserLogin] = 'user has successfully logged in';
		$this->dict['logevent:' . UnbLogEvent::UserLogout] = 'user has logged out';
		$this->dict['logevent:' . UnbLogEvent::UserLoginFailed] = 'user has tried to log in and failed';

		$this->dict['logevent:' . UnbLogEvent::UserDisplayNameChanged] = 'display name of the user was changed';

		$this->dict['logevent:' . UnbLogEvent::MessageRevisionApproved] = 'message revision approved';
		$this->dict['logevent:' . UnbLogEvent::MessageRevisionLocked] = 'message revision locked';
		$this->dict['logevent:' . UnbLogEvent::MessageRevisionUnlocked] = 'message revision unlocked';
		$this->dict['logevent:' . UnbLogEvent::MessageLocked] = 'message locked';
		$this->dict['logevent:' . UnbLogEvent::MessageUnlocked] = 'message unlocked';
		$this->dict['logevent:' . UnbLogEvent::MessageHidden] = 'message hidden';
		$this->dict['logevent:' . UnbLogEvent::MessageUnhidden] = 'message unhidden';
	}

	protected function FormatNumber($number, $decimals, $html)
	{
		return number_format($number, $decimals, '.', ',');
	}

	protected function FormatOrdinalNumber($number, $html)
	{
		if ($number <= 0) return $num;
		if ($number % 10 == 1) return $number . ($html ? '<sup>' : '') . 'st' . ($html ? '</sup>' : '');
		if ($number % 10 == 2) return $number . ($html ? '<sup>' : '') . 'nd' . ($html ? '</sup>' : '');
		if ($number % 10 == 3) return $number . ($html ? '<sup>' : '') . 'rd' . ($html ? '</sup>' : '');
		return $number . ($html ? '<sup>' : '') . 'th' . ($html ? '</sup>' : '');
	}

	protected function FormatTime($datetime, $details, $html)
	{
		$sp = "\xC2\xA0";   // "\xC2\xA0" = utf8_encode("\xA0")

		$str = '';

		if ($details & UnbTimeFormat::Weekday)   // Mon
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('weekday:' . $datetime->format('N')) .
				($details & ~UnbTimeFormat::Weekday ? ',' : '');
		}
		else if ($details & UnbTimeFormat::WeekdayLong)   // Monday
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('weekdaylong:' . $datetime->format('N')) .
				($details & ~UnbTimeFormat::WeekdayLong ? ',' : '');
		}

		if ($details & UnbTimeFormat::Date)   // 01/01/2000
		{
			$str .= (strlen($str) ? $sp : '') .
				$datetime->format('m/d/Y');
			$haveDate = true;
		}
		else if ($details & UnbTimeFormat::DateLong)   // January 1, 2000
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('month:' . $datetime->format('n')) . $sp .
				$datetime->format('j') . ',' . $sp .
				$datetime->format('Y');
			$haveDate = true;
		}

		if ($details & UnbTimeFormat::TimeSec)   // 12:15:00 pm
		{
			$str .= (strlen($str) ? ($haveDate && $html ? $sp . $sp : $sp) : '') .
				$datetime->format('g:i:s a');
		}
		else if ($details & UnbTimeFormat::Time)   // 12:15 pm
		{
			$str .= (strlen($str) ? ($haveDate && $html ? $sp . $sp : $sp) : '') .
				$datetime->format('g:i a');
		}

		if ($details & UnbTimeFormat::TimeZone)   // UTC
		{
			$str .= (strlen($str) ? $sp : '') .
				$datetime->format('T');
		}

		return $str;
	}

	protected function FormatRelativeTime($diff, $context, $html)
	{
		switch ($context)
		{
			case UnbTimeContext::Point:
				if ($diff->invert)   // 2 years ago
					$grammar = 1;
				else   // in 2 years
					$grammar = 1;
				break;

			case UnbTimeContext::Span:
				if ($diff->invert)   // for 2 years
					$grammar = 1;
				else   // for 2 years
					$grammar = 1;
				break;

			case UnbTimeContext::Before:
				if ($diff->invert)   // 2 years before
					$grammar = 1;
				else   // 2 years later
					$grammar = 1;
				break;
		}

		$parts = array();
		if ($diff->y && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':years', $diff->y));
		if ($diff->m && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':months', $diff->m));
		if ($diff->d && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':days', $diff->d));
		if ($diff->h && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':hours', $diff->h));
		if ($diff->i && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':minutes', $diff->i));
		if ($diff->s && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':seconds', $diff->s));

		$str = '';
		foreach ($parts as $part)
		{
			$str .= (strlen($str) ? UnbLocale::Translate('time:combine') : '') .
				$part;
		}

		switch ($context)
		{
			case UnbTimeContext::Point:
				if ($diff->invert)   // 2 years ago
					$str = self::Translate('time:pattern point past', 'time', $str);
				else   // in 2 years
					$str = self::Translate('time:pattern point future', 'time', $str);
				break;

			case UnbTimeContext::Span:
				if ($diff->invert)   // for 2 years
					$str = self::Translate('time:pattern span past', 'time', $str);
				else   // for 2 years
					$str = self::Translate('time:pattern span future', 'time', $str);
				break;

			case UnbTimeContext::Before:
				if ($diff->invert)   // 2 years before
					$str = self::Translate('time:pattern before past', 'time', $str);
				else   // 2 years later
					$str = self::Translate('time:pattern before future', 'time', $str);
				break;
		}
		return $str;
	}

}

// Automatically register this locale
UnbLocale::Register(new UnbLocale_en_US());

?>
